<?php

namespace Lean;

use Picea\Compiler;
use Picea\Language\DefaultRegistrations;
use Picea\{ Ui\Ui, Asset\Asset };

class PiceaDefaultRegistration extends DefaultRegistrations {

    public function __construct(
        protected array $extensions,
        protected array $syntaxes,
        protected array $controlStructures,
        public null|Ui $ui,
        public null|Asset $asset,
    ) {
        parent::__construct($this->extensions, $this->syntaxes, $this->controlStructures);
    }

    public function registerAll(Compiler $compiler) : void
    {
        parent::registerAll($compiler);

        $this->ui AND $this->ui->registerFormExtension($compiler);
        $this->asset AND $this->asset->registerExtension($compiler);
    }
}